- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# osg::Impostor Class Reference

Impostor - is a form of Level Of Detail group node which allows both switching between children depending on distance from eye point and image caching. More...

Inheritance diagram for osg::Impostor:

[legend]
List of all members.

## Public Types
typedef std::vector< ref_ptr< ImpostorSprite > > | ImpostorSpriteList
## Public Member Functions
| Impostor ()
| Impostor (const Impostor &es, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Impostor)
void | setImpostorThreshold (float distance)
| Set the Impostor threshold distance.
void | setImpostorThresholdToBound (float ratio=1.0f)
| Set the Impostor threshold distance relative to the node's bounding sphere's radius.
float | getImpostorThreshold () const
float | getImpostorThreshold2 () const
ImpostorSprite * | findBestImpostorSprite (unsigned int contextID, const osg::Vec3 &currLocalEyePoint) const
| Find the ImposterSprite which fits the current eye point best.
void | addImpostorSprite (unsigned int contextID, ImpostorSprite *is)
| Add an ImpostorSprite to the Impostor.
ImpostorSpriteList & | getImpostorSpriteList (unsigned int contexID)
| Get the list of ImpostorSprites attached to this Impostor.
const ImpostorSpriteList & | getImpostorSpriteList (unsigned int contexID) const
| Get a const list of ImpostorSprites attached to this const Impostor.
## Protected Member Functions
virtual | ~Impostor ()
virtual bool | computeBound () const
| Compute the bounding sphere around Node's geometry or children.
## Protected Attributes
buffered_object< ImpostorSpriteList > | _impostorSpriteListBuffer
float | _impostorThreshold

## Detailed Description

Impostor - is a form of Level Of Detail group node which allows both switching between children depending on distance from eye point and image caching.

The principle behind Imposters is that they cache an image of real geometry and then the image is drawn in subsequent frames instead of the real geometry. It's a bit like a Billboard *but* is updated at runtime and w.r.t view point. By drawing just the texture mapped quad you can cut down scene complexity and improve performance.

For more details have a look at:

http://grail.cs.washington.edu/projects/hic/

The OSG doesn't implement exactly the same technique as above, but its should be a good starting place. The OSG's impostors are much less intrusive since you don't need to restructure your whole scene to use them.

All you need to do to use Impostors is to set up the visible range values for each LOD child of the Impostor, as per osg::LOD, and set an Impostor threshold to tell the renderer at what distance the Impostor's image caching should cut in. The osg::CullVisitor automatically handles all the setting of pre-rendering stages to calculate the required ImpostorSprites (which encapsulates the image cache and quad), and updates them as the view point changes. If you use osg::SceneView/CullVisitor all the complexity of supporting Impostor will be nicely hidden away.

TODO: Various improvements are planned for the Impostor- 1) Estimation of how many frames an ImpostorSprite will be reused, if it won't be used more often than a minimum threshold then do not create ImpostorSprite - use the real geometry. 2) Sharing of texture memory between ImpostorSprites. 3) Simple 3D geometry for ImpostorSprite's rather than Billboarding. 4) Shrinking of the ImpostorSprite size to more closely fit the underlying geometry.

## Member Typedef Documentation

typedef std::vector< ref_ptr<ImpostorSprite> > osg::Impostor::ImpostorSpriteList

## Constructor & Destructor Documentation

Impostor::Impostor | ( |  | ) |

osg::Impostor::Impostor | ( | const Impostor & | es,
|  | const CopyOp & | copyop = `CopyOp::SHALLOW_COPY`
| ) | `[inline]`

virtual osg::Impostor::~Impostor | ( |  | ) | `[inline, protected, virtual]`

## Member Function Documentation

void Impostor::addImpostorSprite | ( | unsigned int | contextID,
|  | ImpostorSprite * | is
| ) |

| Add an ImpostorSprite to the Impostor.

bool Impostor::computeBound | ( |  | ) | const`[protected, virtual]`

| Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound(). Reimplemented from osg::LOD.

ImpostorSprite * Impostor::findBestImpostorSprite | ( | unsigned int | contextID,
|  | const osg::Vec3 & | currLocalEyePoint
| ) | const

| Find the ImposterSprite which fits the current eye point best.

const ImpostorSpriteList& osg::Impostor::getImpostorSpriteList | ( | unsigned int | contexID | ) | const`[inline]`

| Get a const list of ImpostorSprites attached to this const Impostor.

ImpostorSpriteList& osg::Impostor::getImpostorSpriteList | ( | unsigned int | contexID | ) | `[inline]`

| Get the list of ImpostorSprites attached to this Impostor.

float osg::Impostor::getImpostorThreshold | ( |  | ) | const`[inline]`

float osg::Impostor::getImpostorThreshold2 | ( |  | ) | const`[inline]`

osg::Impostor::META_Node | ( | osg | ,
|  | Impostor |
| ) |

void osg::Impostor::setImpostorThreshold | ( | float | distance | ) | `[inline]`

| Set the Impostor threshold distance. For eye points further than this threshold the Imposter is used if appropriate, otherwise the LOD children as chosen as per a standard LOD node.

void osg::Impostor::setImpostorThresholdToBound | ( | float | ratio = `1.0f` | ) | `[inline]`

| Set the Impostor threshold distance relative to the node's bounding sphere's radius.

## Member Data Documentation

buffered_object<ImpostorSpriteList> osg::Impostor::_impostorSpriteListBuffer`[mutable, protected]`

float osg::Impostor::_impostorThreshold`[protected]`

The documentation for this class was generated from the following files:

- Impostor
- Impostor.cpp